<?php
/////////////////////////
//// make dnssec type zone file.
////              Ver. 0.3 by 2024/11/05
////              Make by Y.Ushijima.
//// <<caution>>
////  Use this software at your own risk! 
/////////////////////////

// dim
///////// Please your input items. 
// position
$nameddir="/etc/named.conf";		// named.conf position
$zonedir="/var/named";			// zone file position
$keydir="/var/named/keys";		// save of ksk and zsk file
$recfile="/usr/local/share/dnssec";	// dnssec record file

// domain
//$domain="hogehoge.co.jp";		// Your domain
$domain="usi.nu";			// Your domain

// zone file name
//$zfn="hogehoge.zone";			// Forward lookup file
$zfn="usi.zone";			// Forward lookup file

// how long days
$hl_ksk="720";				// KSK validity period by days
$hl_zsk="120";				// ZSK validity period by days
$hl_syomei="200";			// signature validity period by days

//////////  EOF 

// date and time
date_default_timezone_set('Asia/Tokyo');
$date = new DateTime();
$tday=$date->format('Ymd');
$ima=$date->format('YmdHis');

// check keys directory
if (is_dir($zonedir . "/keys")) {
	// Directory OK!
} else {
	mkdir($zonedir . "/keys",0755);
	chown($keydir,"named");
	chgrp($keydir,"named");
}

// file read
$zonefile=$zonedir . "/" . $zfn;
$gyou=file($zonefile);
$serial_gyou=null;

foreach ($gyou as $lineNumber => $line) {
	// get srial gyou
	if (str_contains($line,"serial")) {
		$serial_gyou = $lineNumber;
//		echo $ln . " -> " . $line;
	}
}

// Variable
$output=null;
$zsk=null;
$zska=null;
$zskd=null;
$ksk=null;
$kska=null;
$kskd=null;

////////////
// dnskey //
////////////

// move key directry 
chdir ($keydir);

// make ZSK
system("dnssec-keygen -a ECDSAP256SHA256 -P " . $ima . " -A " . $ima . " -D +" . $hl_zsk . "D -n zone " . $domain,$output);

// make KSK
system("dnssec-keygen -f KSK -a ECDSAP256SHA256 -P " . $ima . " -A " . $ima . " -D +" . $hl_ksk . "D -n zone " . $domain,$output);

//exec("grep -l " . $tday . " *.key |xargs grep -l 256",$zsk,$output);
exec("grep -l " . $tday . " *.key |xargs grep -l 256 | xargs ls -t",$zsk,$output);
echo $zsk[0] . "\n";

//exec("grep -l " . $tday . " *.key |xargs grep -l 257",$ksk,$output);
exec("grep -l " . $tday . " *.key |xargs grep -l 257 | xargs ls -t",$ksk,$output);
echo $ksk[0] . "\n";

//////////////////
// zone file    //
//////////////////

// move zone directroy
chdir ($zonedir);

// serial number update
// get space
$sp=mb_strpos($gyou[$serial_gyou],"2");
$spe=substr($gyou[$serial_gyou],0,$sp);

// serial counter plus one
$csn=substr(trim($gyou[$serial_gyou]),0,8);
if ($csn!=$tday) {
	// serial day is not match!
	$gyou[$serial_gyou]=$tday . "00";
}

$sn=substr(trim($gyou[$serial_gyou]),0,10) + 1;

// make serial gyou
$gyou[$serial_gyou]= $spe . $sn . "	; serial\n";

// backup zone file and make empty zone file

// fast line
exec("mv " .$zfn . " " . $zfn . $tday,$temp,$output);
exec("touch " . $zfn,$temp,$output);

// zone write start
$n=0;
foreach ($gyou as $ln => $line) {
	if (str_contains($line,"zone-signing")) {
		// dnskey delete line
	} else {
        file_put_contents($zfn,$gyou[$n],FILE_APPEND);
        $n = $n +1 ;
	}
}

// KSK and ZSK plus
$kp="\$include \"" . $keydir . "/" . $ksk[0] . "\" ; zone-signing KSK\n";
$zp="\$include \"" . $keydir . "/" . $zsk[0] . "\" ; zone-signing ZSK\n";

file_put_contents($zfn,$kp . $zp,FILE_APPEND);

// make singe
chdir ($keydir);
$ksks=substr($ksk[0],0,strlen($ksk[0])-4);
$zsks=substr($zsk[0],0,strlen($zsk[0])-4);

system("dnssec-signzone -H 0 -3 \"\" -s now -e +" . $hl_syomei . "d -o " . $domain . " -k " . $ksks . " " . $zonedir . "/" . $zfn . " " . $zsks,$output);
//system("dnssec-signzone -H 3 -3 1234 -s now -e +" . $hl_syomei . "d -o " . $domain . " -k " . $ksks . " " . $zonedir . "/" . $zfn . " " . $zsks,$output);
//echo "dnssec-signzone -H 3 -3 1234 -s now -e +" . $hl_syomei . "d -o " . $domain . " -k " . $ksks . " " . $zonedir . "/" . $zfn . " " . $zsks;

//////////////////
//  named.conf  //
//////////////////

// check find 'zone file plus .signed' 
//echo "grep -l " . $zfn . " " .  $nameddir . "\n";
exec("grep -l " . $zfn . ".signed " . $nameddir,$ndc,$output);
//echo "ans =" . $ndc[0] . "<-\n";

// no .signed gyou
if (empty($ndc[0])) {
	// read named.conf file
	$namedconf=file($nameddir);
        $n=0;
        // meke named.conf backup
        exec("mv " . $nameddir . " " . $nameddir . "_" . $tday,$temp,$output);
        exec("touch " . $nameddir,$temp,$output);
        chmod($nameddir,644);

        // named.conf crawl
        foreach($namedconf as $ln => $line) {
		//              echo "ln = " . $ln . " namedconf=" . $namedconf[$ln] . "\n";
		// search zone gyou             
		if (str_contains($line,$zfn)) {
			// << Hit >>
                        // make up zone gyou
                        $sp=mb_strpos($namedconf[$ln],"f");
                        $spe=substr($namedconf[$ln],0,$sp);
                        // echo "speace is " . strlen($spe) . "\n";
                        $fz=$spe . "file \"" . $zfn . ".signed\";\n";
                        // old word comment out
                        file_put_contents($nameddir,"//" . $namedconf[$ln],FILE_APPEND);
                        // insert signed gyou
                        file_put_contents($nameddir,$fz,FILE_APPEND);
                } else {
			// << none >>
                        // other gyou return
                        file_put_contents($nameddir,$namedconf[$ln],FILE_APPEND);
                }
        }

}


// named server reload
exec("/usr/sbin/rndc reload",$temp,$output);

// make ds record
exec("dnssec-dsfromkey -2 " . $ksk[0] . " > ds-" . $ksks,$temp,$output); 

// last massages.
$msg1="\n作業終了。\nDSレコードをドメイン代行業者に報告してください。\n作成したファイルを利用した時点ですべて自己責任となります。\n\n";
$msg1=$msg1 . "Work done. \nPlease report the DS record to your domain agent. \nYou will be responsible for everything when you use the created file.\n\n";
$msg1=$msg1 . "<<<<< DS record by KSK >>>>>\n";
$msg2=file_get_contents($zonedir . "/keys/ds-" . $ksks);

$msg3="KSK = " . $ksks . "\n";
exec("grep Activate " . $keydir . "/" . $ksks . ".key",$kskax,$output);
$kska = $kskax[0];
$msg3=$msg3 . "      " . substr($kska,1,15) . "/" . substr($kska,16,2) . "/" . substr($kska,18,2) . " " . substr($kska,20,2) . ":" . substr($kska,22,2) . ":" . substr($kska,24,2) . " JST\n";
exec("grep Delete " . $ksk[0],$kskdx,$output);
$kskd=$kskdx[0];
$msg3=$msg3 . "       Delete:   " . substr($kskd,10,4) . "/" . substr($kskd,14,2) . "/" . substr($kskd,16,2) . " " . substr($kskd,18,2) . ":" . substr($kskd,20,2) . ":" . substr($kskd,22,2) . " UTC\n";

$msg4="ZSK = " . $zsks . "\n";
exec("grep Activate " . $zsk[0],$zskax,$output);
$zska=$zskax[0];
$msg4=$msg4 . "      " . substr($zska,1,15) . "/" . substr($zska,16,2) . "/" . substr($zska,18,2) . " " . substr($zska,20,2) . ":" . substr($zska,22,2) . ":" . substr($zska,24,2) . " JST\n";
exec("grep Delete " . $zsk[0],$zskdx,$output);
$zskd=$zskdx[0];
$msg4=$msg4 . "       Delete:   " . substr($zskd,10,4) . "/" . substr($zskd,14,2) . "/" . substr($zskd,16,2) . " " . substr($zskd,18,2) . ":" . substr($zskd,20,2) . ":" . substr($zskd,22,2) . " UTC\n";

// display print
echo $msg1 . $msg2 . "\n";
echo "-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n";
echo $msg3 . $msg4 . "\n";

// msg to file
// check dnssec rec directory
if (is_dir($recfile)) {
        // Directory OK!
} else {
        mkdir($recfile,0755);
}

$fname="dnssec_insert_" . $ima . ".txt";
file_put_contents($recfile . "/" . $fname,$msg1 . $msg2 . "\n-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" . $msg3 . $msg4);

?>

